export function Tangshan(money,code,codess,CompositeTable,Department,classify,headRow) {
        let newobj = []
        //把这三个数组push到newobj里
        newobj.unshift(money);
        newobj.unshift(code);
        newobj.unshift(Department);
        //跟材料表的数据对比  如果编码一样 则把导入表的列数换成模板的列数
        codess.forEach(c => {
            let codeLength = String(c.code).length;
            let codeToCompare = String(c.code).substring(0, codeLength);
            newobj[1].forEach(column => {
                let columnIdString = String(column.v.v);
                let idToMatch = columnIdString.substring(0, codeLength);
                if (idToMatch === codeToCompare) {
                    column.ccc = c.oneLevel * 1;
                }
            });
        });
        //按照部门划分，去找到他所在科室分类
        newobj = newobj.map(subArr => {
            return subArr.map(obj => {
                let v = obj.v.v;
                for (let key in classify) {
                    if (classify[key].includes(v)) {
                        obj.v.m = key;
                        obj.v.v = key;
                        obj.v.name = key
                        obj.whether = true
                        return obj;
                    }
                }
                obj.whether = false
                return obj;
            });
        });
        newobj[2].forEach((item, i) => {
            if ('name' in newobj[0][i].v) {
                item.v.name = newobj[0][i].v.name;
            }
        });
        //直接luck表格初始化 替换数据
        //找到所在的行数，按照  -的前后去找，前面是标题，后面是标题后的小分类，如选煤，洗煤等
        CompositeTable[0].data = luckysheet.transToData(CompositeTable[0]["celldata"])
        newobj[0].forEach((item) => {
            if (item.v.m !== undefined) {
                let index = item.v.m.indexOf("-");
                if (index !== -1) {
                    let substrBeforeDash = item.v.m.slice(0, index);
                    let DepartColumns = CompositeTable[0]["celldata"].flat().find(obj =>
                        obj.v && obj.v.v && typeof obj.v.v === 'string' && obj.v.v.includes(item.v.m.slice(0, index))
                    );

                    if (DepartColumns && DepartColumns.r) {
                        let index = item.v.m.indexOf("-")
                        if (index !== -1) {
                            let substrAfterDash = item.v.m.slice(index + 1);
                            switch (substrAfterDash) {
                                case '':
                                    item.r = DepartColumns.r;
                                    break;
                                case '原煤':
                                    item.r = DepartColumns.r + 1;
                                    break;
                                case '洗煤':
                                    item.r = DepartColumns.r + 2;
                                    break;
                                case '选煤':
                                    item.r = DepartColumns.r + 3;
                                    break;
                                case '厂区服务':
                                    item.r = DepartColumns.r + 1;
                                    break;
                                default:
                                // 默认情况
                            }
                        }
                    }
                }
            }
        });
        //把原来分类找不到的放到其他数据类型中，最后一列其他列中
        newobj[1].forEach((item, i) => {
            if (item.ccc && newobj[0][i].r < 8) {
                item.c = item.ccc;
                delete item.ccc;
            } else {
                item.c = 10;
            }
        });
        //金额列和行是原先导入表的行列 要替换掉模板表的行列
        newobj[0].forEach((item, i) => {
            if (item.whether) {
                newobj[2][i].r = item.r;
                newobj[2][i].c = newobj[1][i].c;
                newobj[2][i].v.v = Number(newobj[2][i].v.v);
            } else {
                newobj[2][i].r = '';
                newobj[2][i].c = '';
            }
        });
        //同一个单元格的数据 金额相加。
        let i = headRow - 1
        let duplicateData=[]
        let seen = new Map();
        // 根据行列信息合并重复数据并记录索引
        for (let obj of newobj[2]) {
            i += 1;
            let key = obj.r + ',' + obj.c;
            if (seen.has(key)) {
                let existingObj = seen.get(key);
                existingObj.v.v += obj.v.v;
                existingObj.v.m = (parseInt(existingObj.v.m) + parseInt(obj.v.m)).toString();
                existingObj.index.push(newobj[1][i].r);
            } else {
                obj.index = [newobj[1][i].r];
                seen.set(key, obj);
            }
        }
        // 将合并后的数据放入 duplicateData 数组
        for (let obj of seen.values()) {
            if (obj.v.v > 0 || parseInt(obj.v.m) > 0) {
                duplicateData.push(obj);
            }
        }
      duplicateData = duplicateData.map(item => {
            return {
                ...item,
                v: {
                    ...item.v,
                    v: isNaN(item.v.v) ? item.v.v : Number(item.v.v).toFixed(2)
                }
            };
        });
        // 替换金额所在列和行相同的模板表中的数据
        //金额所在列和行，去模板表中查找，如果行列一致则替换
        for (let i = 0; i < duplicateData.length; i++) {
            //     // 对比 c 和 r 是否与 CompositeTable[0]["celldata"] 中相应对象相同
            for (let k = 0; k < CompositeTable[0]["celldata"].length; k++) {
                if (duplicateData[i].r === CompositeTable[0]["celldata"][k].r && duplicateData[i].c === CompositeTable[0]["celldata"][k].c) {
                    // 如果相同，则进行替换
                    CompositeTable[0]["celldata"][k] = duplicateData[i];
                }
            }
        }
        let duplicateDatas={
            duplicateData:duplicateData,
            CompositeTable:CompositeTable
        }
     return duplicateDatas
}