export function danMine(newArray,c,Department,money,code,classify,codess,name,headRow) {
    //单侯矿转换方法&& this.selectname.includes('单侯') 
        //费用来源
            let headRows = newArray[0].celldata.flat().filter(obj => obj.r && obj.r === headRow && obj.c > 0)
            // 清空money数组中的属性
            money.forEach(item => {
                item.Department = '';
                item.code = '';
                item.cc = '';
                item.fyly = '';
                item.rr = '';
                item.index = item.r
            });
            // 更新money数组中的属性
            money = money.filter(item => {
                let matchingCode = code.find(c => c.r === item.r);
                if (matchingCode) {
                    item.code = matchingCode.v.v;
                }

                let matchingRemark = Department.find(r => r.r === item.r);
                if (matchingRemark) {
                    item.Department = matchingRemark.v.v;
                }

                let matchingFyly = name.find(f => f.r === item.r);
                if (matchingFyly) {
                    item.fyly = matchingFyly.v.v;
                }

                return (matchingCode && matchingRemark && matchingFyly);
            });
            money.forEach((item) => {
                if (item.Department.includes('物管科')) {
                    item.Department = '物管科';
                }
                if (item.Department.endsWith('储运科')) {
                    item.Department = '储运科';
                }
                if (item.Department.includes('生活')) {
                    item.Department = '生活科'
                }
                if(item.fyly !=='生产成本'){
                    item.Department=item.fyly
                }
            });
            money = money.map(obj => {
                let v = obj.Department;
                for (let key in classify) {
                    if (classify[key].includes(v)) {
                        obj.v.name = key;
                        obj.whether = true;
                        return obj;
                    }
                }
                return obj;
            });
            for (let i = 0; i < codess.length; i++) {
                let codeLength = String(codess[i].code).length;
                let codeToCompare = String(codess[i].code).substring(0, codeLength);
                for (let k = 0; k < money.length; k++) {
                    let columnIdString = String(money[k].code);
                    let idToMatch = columnIdString.substring(0, codeLength);
                    if (idToMatch === codeToCompare) {
                        money[k].cc = codess[i].oneLevel * 1
                    }
                }
            }
            let synthesis = newArray
            let head = synthesis[0].celldata.flat().filter(obj => obj.c == 0 && obj.r > 4)
            head.forEach(itemA => {
                let targetRemark = itemA.v.v; // 需要匹配的目标值，这里是 a 属性中的 v.v
                money.forEach(itemB => {
                    if (itemB.Department.includes(targetRemark)) { // 使用 include 方法进行模糊匹配
                        itemB.rr = itemA.r; // 如果匹配到，则将 a 属性中的 r 的值赋给 b 属性中的 rr
                    }
                });
            });
            for (let i = 0; i < money.length; i++) {
                if (money[i].rr) {
                    money[i].r = money[i].rr
                }
                if (money[i].cc) {
                    money[i].c = money[i].cc * 1
                }
                if (!money[i].cc) {
                    money[i].c = 10
                }
                if (!money[i].rr) {
                    money[i].r = ''
                }
            }
            let seen = new Map();
            let duplicateData = [];
            for (let obj of money) {
                let key = obj.r + ',' + obj.c;
                if (seen.has(key)) {
                    let existingObj = seen.get(key);
                    existingObj.v.v = Number(existingObj.v.v) + Number(obj.v.v);
                    existingObj.v.m = existingObj.v.v.toString();
                    existingObj.v.m = Number(existingObj.v.v).toFixed(2);
                    existingObj.index.push(obj.index)
                } else {
                    obj.index = [obj.index]
                    seen.set(key, obj);
                }
            }
            for (let obj of seen.values()) {
                if (Math.abs(obj.v.v) > 0 || Math.abs(parseInt(obj.v.m)) > 0) {
                    duplicateData.push(obj);
                }
            }
            duplicateData.forEach(obj=>{
                obj.v.v = Number(obj.v.v).toFixed(2);
                obj.v.m = Number(obj.v.v).toFixed(2);
            })
            for (let i = 0; i < duplicateData.length; i++) {
                //     // 对比 c 和 r 是否与 he[0]["celldata"] 中相应对象相同
                for (let k = 0; k < synthesis[0]["celldata"].length; k++) {
                    if (duplicateData[i].r === synthesis[0]["celldata"][k].r && duplicateData[i].c === synthesis[0]["celldata"][k].c) {
                        // 如果相同，则进行替换
                        synthesis[0]["celldata"][k] = duplicateData[i];
                    }
                }
            }
            let duplicateJSON= JSON.stringify(duplicateData)
            duplicateJSON=JSON.parse(duplicateJSON)
            duplicateJSON.forEach(item => {
                const matchedHeadRow = headRows.find(headItem => headItem.c === item.c);
                if (matchedHeadRow) {
                    item.v.material = matchedHeadRow.v.v;
                }
            });
            for (let i = 0; i < duplicateJSON.length; i++) {
                if (duplicateJSON[i].r > 4 && duplicateJSON[i].r < 16) {
                    //管理费用
                    duplicateJSON[i].r = 6
                    duplicateJSON[i].c = 12

                }
                if (duplicateJSON[i].r > 16 && duplicateJSON[i].r < 27) {
                    //制造费用
                    duplicateJSON[i].r = 7
                    duplicateJSON[i].c = 10


                }
                if (duplicateJSON[i].r > 28 && duplicateJSON[i].r < 43) {
                    //基本费用
                    duplicateJSON[i].r = 8

                }
                if (duplicateJSON[i].r > 43 && duplicateJSON[i].r < 46) {
                    //销售费用
                    duplicateJSON[i].r = 9
                    duplicateJSON[i].c = 10


                }
                if (duplicateJSON[i].r > 46 && duplicateJSON[i].r < 48 ||(!duplicateJSON[i].r)) {
                    //其他业务
                    duplicateJSON[i].r = 10
                    duplicateJSON[i].c = 10
                }

                if (duplicateJSON[i].r > 49 && duplicateJSON[i].r < 51) {
                    //安全费用  
                    duplicateJSON[i].r = 11
                    duplicateJSON[i].c = 10
                }
            }
            let seens = new Map();
            let duplicateDatas = [];
            for (let obj of duplicateJSON) {
                let key = obj.r + ',' + obj.c;
                if (seens.has(key)) {
                    let existingObj = seens.get(key);
                    existingObj.v.v = Number(existingObj.v.v) + Number(obj.v.v);
                    existingObj.v.m = existingObj.v.v.toString();
                    existingObj.index.push(...obj.index)
                } else {
                    obj.index=[...obj.index]
                    seens.set(key, obj);
                }
            }
            for (let obj of seens.values()) {
                if (obj.v.v > 0 || parseInt(obj.v.m) > 0) {
                    duplicateDatas.push(obj);
                }
            }
            duplicateJSON = duplicateJSON.filter(item => item.v && item.v.name);
            duplicateJSON.forEach(items=>{
                items.v.v = Number(items.v.v).toFixed(2);
                items.v.m = items.v.v.toString();
                items.v.m = Number(items.v.m).toFixed(2);
            })
            let duplic={
                duplicateData:duplicateJSON,
                CompositeTable:synthesis
            }
            return duplic
}